Index: trunk/LMDZ.MARS/libf/phymars/improvedCO2clouds.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/improvedCO2clouds.F	(revision 1779)
+++ trunk/LMDZ.MARS/libf/phymars/improvedCO2clouds.F	(revision 1816)
@@ -1,17 +1,11 @@
       subroutine improvedCO2clouds(ngrid,nlay,ptimestep,
-     &             pplay,pzlev,pt,pdt,
+     &             pplay,pplev,pt,pdt,
      &             pq,pdq,pdqcloudco2,pdtcloudco2,
      &             nq,tauscaling,
      &             memdMMccn,memdMMh2o,memdNNccn)
-! to use  'getin'
       USE comcstfi_h
       USE ioipsl_getincom
       USE updaterad
       use tracer_mod
-!, only: rho_ice_co2, nuiceco2_sed, igcm_co2,
-!     &                      rho_ice,igcm_h2o_ice, igcm_ccn_number,
-!     &                      igcm_co2_ice, igcm_dust_mass,
-!     &                      igcm_dust_number, igcm_ccnco2_mass,
-!    &                      igcm_ccnco2_number
       use conc_mod, only: mmean
 
@@ -45,15 +39,12 @@
 c Adaptation for CO2 clouds by Joachim Audouard (09/16), based on the work
 c of Constantino Listowski 
+c Warning:
+c If meteoritic particles are activated and turn into co2 ice particles,
+c then they will be reversed in the dust tracers if the cloud sublimates
+ 
 c------------------------------------------------------------------
-!#include "dimensions.h"
-!#include "dimphys.h"
 #include "callkeys.h"
-!#include "tracer.h"
-!#include "comgeomfi.h"
-!#include "dimradmars.h"
 #include "microphys.h"
 #include "datafile.h"
-!#include "microphysCO2.h"
-!#include "conc.h"
 c------------------------------------------------------------------
 c     Inputs:
@@ -63,6 +54,6 @@
       REAL ptimestep             ! pas de temps physique (s)
       REAL pplay(ngrid,nlay)     ! pression au milieu des couches (Pa)
-      REAL pzlev(ngrid,nlay)     ! altitude au milieu des couches ()
-
+      REAL pplev(ngrid,nlay+1)   ! pression inter couches (Pa)
+      real masse (ngrid,nlay) ! Layer mass (kg.m-2)
       REAL pt(ngrid,nlay)        ! temperature at the middle of the
                                  !   layers (K)
@@ -73,9 +64,7 @@
                                  !   (kg/kg.s-1)
       REAL tauscaling(ngrid)     ! Convertion factor for qdust and Ndust
-
       REAL rice(ngrid,nlay)    ! Water Ice mass mean radius (m)
                                 ! used for nucleation of CO2 on ice-coated ccns
       REAL rccnh2o(ngrid,nlay)    ! Water Ice mass mean radius (m)
-
 c     Outputs:
       REAL pdqcloudco2(ngrid,nlay,nq) ! tendance de la condensation
@@ -87,15 +76,8 @@
 c------------------------------------------------------------------
 c     Local variables:
-
       LOGICAL firstcall
       DATA firstcall/.true./
       SAVE firstcall
-
       REAL*8   derf ! Error function
-      !external derf
-
-      !REAL*8   massflowrateCO2 
-      !external massflowrateCO2
-     
       INTEGER ig,l,i,flag_pourri
       
@@ -104,10 +86,12 @@
       REAL zt(ngrid,nlay)       ! local value of temperature
       REAL zqsat(ngrid,nlay)    ! saturation vapor pressure for CO2
+      real tcond(ngrid,nlay)
+      real zqco2(ngrid,nlay)
       REAL lw                         !Latent heat of sublimation (J.kg-1) 
       REAL,save :: l0,l1,l2,l3,l4
-      REAL cste
       DOUBLE PRECISION dMice           ! mass of condensed ice
       DOUBLE PRECISION sumcheck
-      DOUBLE PRECISION pco2     ! Co2 vapor partial pressure (Pa)
+      DOUBLE PRECISION facteurmax!for energy limit on mass growth
+      DOUBLE PRECISION pco2,psat  ! Co2 vapor partial pressure (Pa)
       DOUBLE PRECISION satu ! Co2 vapor saturation ratio over ice
       DOUBLE PRECISION Mo,No
@@ -116,5 +100,5 @@
       DOUBLE PRECISION memdMMh2o(ngrid,nlay)
       DOUBLE PRECISION memdNNccn(ngrid,nlay)
-
+      
 !     Radius used by the microphysical scheme (m)
       DOUBLE PRECISION n_aer(nbinco2_cld) ! number concentration volume-1 of particle/each size bin
@@ -149,46 +133,29 @@
 c     Parameters of the size discretization
 c       used by the microphysical scheme
-      DOUBLE PRECISION, PARAMETER :: rmin_cld = 1.e-11 ! Minimum radius (m)
-      DOUBLE PRECISION, PARAMETER :: rmax_cld = 3.e-6 ! Maximum radius (m)
-      DOUBLE PRECISION, PARAMETER :: rbmin_cld =1.e-12
-                                           ! Minimum bounary radius (m)
-      DOUBLE PRECISION, PARAMETER :: rbmax_cld = 5.e-6 ! Maximum boundary radius (m)
+      DOUBLE PRECISION, PARAMETER :: rmin_cld = 1.e-9 ! Minimum radius (m)
+      DOUBLE PRECISION, PARAMETER :: rmax_cld = 5.e-6 ! Maximum radius (m)
+      DOUBLE PRECISION, PARAMETER :: rbmin_cld =1.e-10! Minimum bounary radius (m)
+      DOUBLE PRECISION, PARAMETER :: rbmax_cld = 2.e-4 ! Maximum boundary radius (m)
       DOUBLE PRECISION vrat_cld ! Volume ratio
       DOUBLE PRECISION rb_cldco2(nbinco2_cld+1) ! boundary values of each rad_cldco2 bin (m)
       SAVE rb_cldco2
-      
-      DOUBLE PRECISION dr_cld(nbinco2_cld)   ! width of each rad_cldco2 bin (m)
+      DOUBLE PRECISION dr_cld(nbinco2_cld) ! width of each rad_cldco2 bin (m)
       DOUBLE PRECISION vol_cld(nbinco2_cld)  ! particle volume for each bin (m3)
 
       DOUBLE PRECISION Proba,Masse_atm,drsurdt,reff,Probah2o
-      REAL sigma_iceco2 ! Variance of the ice and CCN distributions
-      SAVE sigma_iceco2
-      
-
-      REAL sigma_ice ! Variance of the ice and CCN distributions
+      REAL sigma_iceco2 ! Variance of the co2 ice and CCN distributions
+      SAVE sigma_iceco2 
+      REAL sigma_ice ! Variance of the h2o ice and CCN distributions
       SAVE sigma_ice
-
       DOUBLE PRECISION Niceco2,Qccnco2,Nccnco2
-      
-      integer coeffh2o
-!Variables for the meteoritic flux
-
-        double precision meteo_ccn(ngrid,nlay,100) !100=nbinco2_cld !!! 
-        double precision,save :: meteo(130,100)
-        double precision mtemp(100)
-        logical file_ok
-        integer altitudes_meteo(130),nelem,lebon1,lebon2
-        double precision :: ltemp1(130),ltemp2(130)
-        integer ibin,uMeteo,j
-c----------------------------------      
-c TESTS
-
-
-
-      REAL satubf(ngrid,nlay),satuaf(ngrid,nlay) 
-      REAL res_out(ngrid,nlay)
- 
-
-c------------------------------------------------------------------
+      integer,save :: coeffh2o  !will be =0 is co2useh2o=.false.
+!     Variables for the meteoritic flux:
+      double precision meteo_ccn(ngrid,nlay,100) !100=nbinco2_cld !!! 
+      double precision,save :: meteo(130,100)
+      double precision mtemp(100),pression_meteo(130)
+      logical file_ok
+      integer nelem,lebon1,lebon2
+      double precision :: ltemp1(130),ltemp2(130)
+      integer ibin,uMeteo,j
 
       IF (firstcall) THEN
@@ -204,21 +171,13 @@
 c       dr_cld is the width of each rad_cldco2 bin.
 
-c       Volume ratio between two adjacent bins
-   !     vrat_cld = log(rmax_cld/rmin_cld) / float(nbinco2_cld-1) *3.
-   !     vrat_cld = exp(vrat_cld)
-        vrat_cld = log(rmax_cld/rmin_cld) / float(nbinco2_cld-1) *3.
-        vrat_cld = exp(vrat_cld)
-c        write(*,*) "vrat_cld", vrat_cld
-
+        vrat_cld = dlog(rmax_cld/rmin_cld) / float(nbinco2_cld-1) *3.
+        vrat_cld = dexp(vrat_cld)
         rb_cldco2(1)  = rbmin_cld
         rad_cldco2(1) = rmin_cld
         vol_cld(1) = 4./3. * dble(pi) * rmin_cld*rmin_cld*rmin_cld
-   !     vol_cld(1) = 4./3. * pi * rmin_cld*rmin_cld*rmin_cld
-
         do i=1,nbinco2_cld-1
           rad_cldco2(i+1)  = rad_cldco2(i) * vrat_cld**(1./3.)
           vol_cld(i+1)  = vol_cld(i) * vrat_cld
-        enddo
-        
+        enddo        
         do i=1,nbinco2_cld
           rb_cldco2(i+1)= ( (2.*vrat_cld) / (vrat_cld+1.) )**(1./3.) *
@@ -229,5 +188,4 @@
         dr_cld(nbinco2_cld)   = rb_cldco2(nbinco2_cld+1) -
      &       rb_cldco2(nbinco2_cld)
-
         print*, ' '
         print*,'Microphysics co2: size bin information:'
@@ -240,7 +198,6 @@
         write(*,'(i3,3x,e12.6)') nbinco2_cld+1,rb_cldco2(nbinco2_cld+1)
         print*,'-----------------------------------'
-
         do i=1,nbinco2_cld+1
-            rb_cldco2(i) = log(rb_cldco2(i))  !! we save that so that it is not computed
+            rb_cldco2(i) = dlog(rb_cldco2(i))  !! we save that so that it is not computed
                                          !! at each timestep and gridpoint
         enddo
@@ -250,7 +207,7 @@
 c        mtetaco2 = 0.952
         write(*,*) 'co2_param contact parameter:', mtetaco2
-
 c       Volume of a co2 molecule (m3)
         vo1 = m0co2 / dble(rho_ice_co2) ! m0co2 et non mco2
+c       below, vo1 will be recomputed using real rho ice co2 (T-dependant)
         vo1co2=vo1 ! AJOUT JA 
 c       Variance of the ice and CCN distributions
@@ -258,8 +215,4 @@
         sigma_ice = sqrt(log(1.+nuice_sed))
 
- 
-c        write(*,*) 'Variance of ice & CCN distribs :', sigma_iceco2
-c        write(*,*) 'nuice for sedimentation:', nuiceco2_sed
-c        write(*,*) 'Volume of a co2 molecule:', vo1co2
   
         write(*,*) 'Variance of ice & CCN CO2 distribs :', sigma_iceco2
@@ -275,6 +228,4 @@
            coeffh2o=1
         endif
-        meteo_ccn(:,:,:)=0.
-
         if (meteo_flux) then
            write(*,*)
@@ -282,7 +233,7 @@
            write(*,*) "meteoritic dust particles are available"
            write(*,*) "for co2 ice nucleation! "
-           write(*,*) "Flux given by J. Plane (altitude,size bins)"
+           write(*,*) "Flux given by J. Plane (pressions,size bins)"
            ! Initialisation of the flux: it is constant and is it saved
-           !We must interpolate the table to the GCM altitudes
+           !We must interpolate the table to the GCM pressures
            INQUIRE(FILE=datafile(1:LEN_TRIM(datafile))//
      &       '/Meteo_flux_Plane.dat', EXIST=file_ok)
@@ -296,14 +247,22 @@
      &          '/Meteo_flux_Plane.dat'
      &          ,FORM='formatted')
-!13000 records (130 altitudes x 100 bin sizes)
+!13000 records (130 pressions x 100 bin sizes)
+           read(uMeteo,*) !skip 1 line
+           do i=1,130 
+              read(uMeteo,*) pression_meteo(i)
+              write(*,*) pression_meteo(i)
+           enddo
+           read(uMeteo,*)       !skip 1 line
            do i=1,130 
               do j=1,100        ! les mêmes 100 bins size que la distri nuclea: on touche pas
                  read(uMeteo,'(F12.6)') meteo(i,j)
               enddo
-              altitudes_meteo(i)=i ! On doit maintenant réinterpoler le tableau(130,100) sur les altitudes du GCM (nlay,100)
+!On doit maintenant réinterpoler le tableau(130,100) sur les pressions du GCM (nlay,100)
            enddo
            close(uMeteo)
-        endif !of if meteo_flux
-
+        write(*,*) "File meteo_flux read, end of firstcall in co2 micro"
+        endif                     !of if meteo_flux
+      
+        ! Parameter values for Latent heat computation
         l0=595594d0      
         l1=903.111d0    
@@ -312,15 +271,10 @@
         l4=-0.000103183d0
         firstcall=.false.
-        
-        
       END IF
-c      write(*,*) "max memdNN =",maxval(memdNNccn)
 !=============================================================
 ! 1. Initialisation
 !=============================================================
-      !cste = 4*pi*rho_ice*ptimestep !not used for co2
       flag_pourri=0
-
-      res_out(:,:) = 0
+      meteo_ccn(:,:,:)=0.
       rice(:,:) = 1.e-8
       riceco2(:,:) = 1.e-11
@@ -335,43 +289,32 @@
      &      pt(1:ngrid,1:nlay) + 
      &      pdt(1:ngrid,1:nlay) * ptimestep 
-c      call WRITEDIAGFI(ngrid,"Ztclouds",
-c     &     "Ztclouds",'K',3,zt)
-c       call WRITEDIAGFI(ngrid,"pdtclouds",
-c     &     "pdtclouds",'K',3,pdt*ptimestep)
-      
       zq(1:ngrid,1:nlay,1:nq) = 
      &      pq(1:ngrid,1:nlay,1:nq) + 
      &      pdq(1:ngrid,1:nlay,1:nq) * ptimestep
-      
-      
       WHERE( zq(1:ngrid,1:nlay,1:nq) < 1.e-30 )
-     &       zq(1:ngrid,1:nlay,1:nq) = 1.e-30
-
-      zq0(1:ngrid,1:nlay,1:nq) = zq(1:ngrid,1:nlay,1:nq)
-      
+     &     zq(1:ngrid,1:nlay,1:nq) = 1.e-30
+         
+         zq0(1:ngrid,1:nlay,1:nq) = zq(1:ngrid,1:nlay,1:nq)
 !=============================================================
 ! 2. Compute saturation
 !=============================================================
-   
-          
-
       dev2 = 1. / ( sqrt(2.) * sigma_iceco2 )
       dev3 = 1. / ( sqrt(2.) * sigma_ice )
-
       call co2sat(ngrid*nlay,zt,pplay,zqsat) !zqsat is psat(co2)
-        
-
-!=============================================================
-!   Bonus: additional meteoritic particles for nucleation
+      zqco2=zq(:,:,igcm_co2)+zq(:,:,igcm_co2_ice)
+      CALL tcondco2(ngrid,nlay,pplay,zqco2,tcond)
+!=============================================================
+! 3. Bonus: additional meteoritic particles for nucleation
 !=============================================================
       if (meteo_flux) then
-         !altitude_meteo(130)
-         !pzlev(ngrid,nlay)
+         !pression_meteo(130)
+         !pplev(ngrid,nlay+1)
          !meteo(130,100)
          !resultat: meteo_ccn(ngrid,nlay,100)
          do l=1,nlay
             do ig=1,ngrid
-               ltemp1=abs(altitudes_meteo(:)-pzlev(ig,l))
-               ltemp2=abs(altitudes_meteo(:)-pzlev(ig,l+1))
+               masse(ig,l)=(pplev(ig,l) - pplev(ig,l+1)) /g 
+               ltemp1=abs(pression_meteo(:)-pplev(ig,l))
+               ltemp2=abs(pression_meteo(:)-pplev(ig,l+1))
                lebon1=minloc(ltemp1,DIM=1) 
                lebon2=minloc(ltemp2,DIM=1)
@@ -381,34 +324,47 @@
                   mtemp(ibin)=sum(meteo(lebon1:lebon2,ibin))
                enddo
-               meteo_ccn(ig,l,:)=mtemp(:)/nelem
+               meteo_ccn(ig,l,:)=mtemp(:)/nelem/masse(ig,l) !Par kg air
+csi par m carre, x epaisseur/masse pour par kg/air 
+               !write(*,*) "masse air ig l=",masse(ig,l)
+               !check original unit with J. Plane
             enddo
          enddo
       endif
-
-c     Main loop over the GCM's grid
+c ------------------------------------------------------------------------
+c ---------  Actual microphysics : Main loop over the GCM's grid ---------
+c ------------------------------------------------------------------------
        DO l=1,nlay
          DO ig=1,ngrid
 c       Get the partial pressure of co2 vapor and its saturation ratio
            pco2 = zq(ig,l,igcm_co2) * (mmean(ig,l)/44.01) * pplay(ig,l)
-c        satu = zq(ig,l,igcm_co2) / zqsat(ig,l)
            satu = pco2 / zqsat(ig,l)
-!=============================================================
-! 3. Nucleation
-!=============================================================
+
            rho_ice_co2T(ig,l)=1000.*(1.72391-2.53e-4*zt(ig,l)
-     &          -2.87e-6*zt(ig,l)*zt(ig,l))
+     &          -2.87e-6*zt(ig,l)*zt(ig,l)) !T-dependant CO2 ice density
            vo2co2 = m0co2 / dble(rho_ice_co2T(ig,l))
            rho_ice_co2=rho_ice_co2T(ig,l)
 
-           IF ( satu .ge. 1d0 ) THEN ! if there is condensation
-
+!=============================================================
+!4. Nucleation
+!=============================================================
+           IF ( satu .ge. 1 ) THEN ! if there is condensation
+
+c     call updaterccn(zq(ig,l,igcm_dust_mass),
+c     &             zq(ig,l,igcm_dust_number),rdust(ig,l),tauscaling(ig))
+
+              !We do rdust computation "by hand" because we don't want to
+              ! change the mininumum rdust value in updaterad... It would
+              ! mess up various part of the GCM !
+              
               rdust(ig,l)= zq(ig,l,igcm_dust_mass)
      &             *0.75/pi/rho_dust
      &             / zq(ig,l,igcm_dust_number)
               rdust(ig,l)= rdust(ig,l)**(1./3.)
-c             write(*,*) "Improved2, l,Rdust = ",l,rdust(ig,l)
-            rdust(ig,l)=max(1.e-9,rdust(ig,l))
-c            rdust(ig,l)=min(1.e-5,rdust(ig,l))
-             ! write(*,*) "Improved3,Rdust = ",rdust(ig,l)
+              if (zq(ig,l,igcm_dust_mass)*tauscaling(ig) .le. 1.e-20 
+     &             .or.  zq(ig,l,igcm_dust_number)*tauscaling(ig) .le.1
+     &             .or. rdust(ig,l) .le. 1.e-9) then
+                 rdust(ig,l)=1.e-9
+              endif
+              rdust(ig,l)=min(5.e-4,rdust(ig,l))
       
 c       Expand the dust moments into a binned distribution
@@ -416,8 +372,8 @@
               No = zq(ig,l,igcm_dust_number)* tauscaling(ig)+1.e-30
               Rn = rdust(ig,l)
-              Rn = -log(Rn) 
+              Rn = -dlog(Rn) 
               Rm = Rn - 3. * sigma_iceco2*sigma_iceco2  
-              n_derf = erf( (rb_cldco2(1)+Rn) *dev2)
-              m_derf = erf( (rb_cldco2(1)+Rm) *dev2)
+              n_derf = derf( (rb_cldco2(1)+Rn) *dev2)
+              m_derf = derf( (rb_cldco2(1)+Rm) *dev2)
       
               do i = 1, nbinco2_cld
@@ -427,64 +383,16 @@
                  m_derf = derf((rb_cldco2(i+1)+Rm) *dev2)
                  n_aer(i) = n_aer(i) + 0.5 * No * n_derf +
-     &                meteo_ccn(ig,l,i) !Ajout meteo_ccn
+     &                meteo_ccn(ig,l,i) !Ajout meteo_ccn particles
                  m_aer(i) = m_aer(i) + 0.5 * Mo * m_derf
                  m_aer2(i)=4./3.*pi*rho_dust
-     &                *n_aer(i)*rad_cldco2(i)*rad_cldco2(i)
+     &                *meteo_ccn(ig,l,i)*rad_cldco2(i)*rad_cldco2(i)
      &                *rad_cldco2(i)
-c                 write(*,*) "diff =",rad_cldco2(i),m_aer(i),m_aer2(i)
               enddo
-c              write(*,*) "Bilan =",sum(m_aer),sum(m_aer2)
+              if (meteo_flux) m_aer(:)=m_aer(:)+m_aer2(:)
               
-c              sumcheck = 0
-c              do i = 1, nbinco2_cld
-c                 sumcheck = sumcheck + n_aer(i)
-c              enddo
-c              sumcheck = abs(sumcheck/No - 1)
-c              if ((sumcheck .gt. 1e-5).and. (1./Rn .gt. rmin_cld)) then
-c                 print*, "WARNING, No sumcheck PROBLEM"
-c                 print*, "sumcheck, No, rdust",sumcheck, No,rdust(ig,l)
-c                 print*, "min radius, Rn, ig, l", rmin_cld, 1./Rn, ig, l
-c                 print*, "Dust binned distribution", n_aer
-c                 STOP
-c              endif
-              
-c              sumcheck = 0
-c              do i = 1, nbinco2_cld
-c                 sumcheck = sumcheck + m_aer(i)
-c              enddo
-c              sumcheck = abs(sumcheck/Mo - 1)
-c              if ((sumcheck .gt. 1e-5) .and.  (1./Rn .gt. rmin_cld))
-c     &             then
-c                 print*, "WARNING, Mo sumcheck PROBLEM"
-c                 print*, "sumcheck, Mo",sumcheck, Mo
-c                 print*, "min radius, Rm, ig, l", rmin_cld, 1./Rm, ig,l
-c                 print*, "Dust binned distribution", m_aer
-c                 STOP
-c              endif
-              m_aer(:)=m_aer2(:)
-              
-              
-              rccnh2o(ig,l)= zq(ig,l,igcm_ccn_mass)
-     &             *0.75/pi/rho_dust
-     &             / zq(ig,l,igcm_ccn_number)
-              
-              rice(ig,l)=( zq(ig,l,igcm_h2o_ice)*3.0/
-     &             (4.0*rho_ice_co2*zq(ig,l,igcm_ccn_number)
-     &             *pi*tauscaling(ig)) +rccnh2o(ig,l)*rccnh2o(ig,l)
-     &             *rccnh2o(ig,l) )**(1.0/3.0)
-              rhocloud(ig,l)=( zq(ig,l,igcm_h2o_ice)*rho_ice
-     &            +zq(ig,l,igcm_ccn_mass) *tauscaling(ig)*rho_dust)
-     &            / (zq(ig,l,igcm_h2o_ice)+zq(ig,l,igcm_ccn_mass)
-     &             *tauscaling(ig))
-c              call updaterice_micro(
-c     &             zq(ig,l,igcm_h2o_ice), ! ice mass
-c     &             zq(ig,l,igcm_ccn_mass), ! ccn mass
-c     &             zq(ig,l,igcm_ccn_number), ! ccn number
-c     &             tauscaling(ig),rice(ig,l),rhocloud(ig,l))
-              ! rice radius of CCN + H20 crystal 
-c              write(*,*) "Improved1 Rice=",rice(ig,l)
-              rice(ig,l)=max(1.e-10,rice(ig,l))
-c              rice(ig,l)=min(1.e-5,rice(ig,l))
-              !write(*,*) "Improved2 Rice=",rice(ig,l)
+              !Same but with h2o particles as CCN
+              call updaterice_micro(zq(ig,l,igcm_h2o_ice),
+     &             zq(ig,l,igcm_ccn_mass),zq(ig,l,igcm_ccn_number),
+     &             tauscaling(ig),rice(ig,l),rhocloud(ig,l))
               Mo = zq(ig,l,igcm_h2o_ice) +
      &             zq(ig,l,igcm_ccn_mass)*tauscaling(ig)+1.e-30!*tauscaling(ig)
@@ -492,8 +400,8 @@
               No = zq(ig,l,igcm_ccn_number)* tauscaling(ig) + 1.e-30
               Rn = rice(ig,l)
-              Rn = -log(Rn) 
+              Rn = -dlog(Rn) 
               Rm = Rn - 3. * sigma_ice*sigma_ice  
-              n_derf = erf( (rb_cldco2(1)+Rn) *dev3)
-              m_derf = erf( (rb_cldco2(1)+Rm) *dev3)
+              n_derf = derf( (rb_cldco2(1)+Rn) *dev3)
+              m_derf = derf( (rb_cldco2(1)+Rm) *dev3)
               do i = 1, nbinco2_cld
                  n_aer_h2oice(i) = -0.5 * No * n_derf 
@@ -504,44 +412,9 @@
                  m_aer_h2oice(i) = m_aer_h2oice(i) + 0.5 * Mo * m_derf 
                  rad_h2oice(i) = rad_cldco2(i)
-                 m_aer_h2oice2(i)=4./3.*pi*rhocloud(ig,l)
-     &                *n_aer_h2oice(i)*rad_h2oice(i)*rad_h2oice(i)
-     &                *rad_h2oice(i)
-                 
-
-c                 write(*,*) "before nuc, i,rad_h2o(i)= ",i,rad_cldco2(i)
-c     &                ,m_aer_h2oice(i),n_aer_h2oice(i)
               enddo
-c              sumcheck = 0
-c              do i = 1, nbinco2_cld
-c                 sumcheck = sumcheck + n_aer_h2oice(i)
-c              enddo
-c              sumcheck = abs(sumcheck/No - 1)
-c              if ((sumcheck .gt. 1e-5).and. (1./Rn .gt. rmin_cld)) then
-c                 print*, "WARNING, Noh2o sumcheck PROBLEM"
-c                 print*, "sumcheck, No, rice",sumcheck, No,rice(ig,l)
-c                 print*, "min radius, Rn, ig, l", rmin_cld, 1./Rn, ig, l
-c                 print*, "Dust binned distribution", n_aer_h2oice
-c                 STOP
-c              endif
-              
-c            sumcheck = 0
-c              do i = 1, nbinco2_cld
-c                 sumcheck = sumcheck + m_aer_h2oice(i)
-c              enddo
-c              sumcheck = abs(sumcheck/Mo - 1)
-c              if ((sumcheck .gt. 1e-5) .and.  (1./Rn .gt. rmin_cld))
-c     &             then
-c                 print*, "WARNING, Moh2o sumcheck PROBLEM"
-c                 print*, "sumcheck, Mo",sumcheck, Mo
-c                 print*, "min radius, Rm, ig, l", rmin_cld, 1./Rm, ig,l
-c                 print*, "Dust binned distribution", m_aer_h2oice
-c                 STOP
-c              endif
-c       Get the rates of nucleation
-
+              !Call to nucleation routine
               call nucleaCO2(dble(pco2),zt(ig,l),dble(satu)
      &             ,n_aer,rate,n_aer_h2oice
      &             ,rad_h2oice,rateh2o,vo2co2)
-              m_aer_h2oice(:)=m_aer_h2oice2(:)
               dN = 0.
               dM = 0.
@@ -550,40 +423,20 @@
               do i = 1, nbinco2_cld
                  Proba=1.0-dexp(-1.*ptimestep*rate(i))
-                 Probah2o=coeffh2o*(1.0-dexp(-1.*ptimestep*rateh2o(i)))
+                 Probah2o=coeffh2o*(1.0-dexp(-1.*ptimestep*rateh2o(i))) !if co2useh2o=.false., this is =0
                  dNh2o    = dNh2o + n_aer_h2oice(i) * Probah2o
                  dMh2o    = dMh2o + m_aer_h2oice(i) * Probah2o
                  dN       = dN + n_aer(i) * Proba
-                 dM       = dM + m_aer(i) * Proba
-             
+                 dM       = dM + m_aer(i) * Proba             
               enddo
         ! dM  masse activée (kg) et dN nb particules par  kg d'air
-            
+        ! Now increment CCN tracers and update dust tracers
               dNN= dN/tauscaling(ig)
               dMM= dM/tauscaling(ig)
               dNN=min(dNN,zq(ig,l,igcm_dust_number))
               dMM=min(dMM,zq(ig,l,igcm_dust_mass))
-           !   if (dNN .gt. 0) then
-           !      write(*,*) "Nuclea dNN crees=",dNN
-           !      write(*,*) "Nuclea dMM crees=",dMM
-           !   endif
-              dNNh2o=dNh2o/tauscaling(ig)
-              dNNh2o=min(dNNh2o,zq(ig,l,igcm_ccn_number))
-
-              ratioh2o_ccn=1./(zq(ig,l,igcm_h2o_ice)
-     &             +zq(ig,l,igcm_ccn_mass)*tauscaling(ig))          
-    
-              dMh2o_ice=dMh2o*zq(ig,l,igcm_h2o_ice)*ratioh2o_ccn
-              dMh2o_ccn=dMh2o*zq(ig,l,igcm_ccn_mass)*
-     &             tauscaling(ig)*ratioh2o_ccn
-  
-              dMh2o_ccn=dMh2o_ccn/tauscaling(ig)
-              dMh2o_ccn=min(dMh2o_ccn,zq(ig,l,igcm_ccn_mass))
-              dMh2o_ice=min(dMh2o_ice,zq(ig,l,igcm_h2o_ice))
-
               zq(ig,l,igcm_ccnco2_mass)   = 
      &             zq(ig,l,igcm_ccnco2_mass)   + dMM
               zq(ig,l,igcm_ccnco2_number) =
      &             zq(ig,l,igcm_ccnco2_number) + dNN
-
               zq(ig,l,igcm_dust_mass)= zq(ig,l,igcm_dust_mass)-dMM 
               zq(ig,l,igcm_dust_number)=zq(ig,l,igcm_dust_number)-dNN
@@ -591,17 +444,26 @@
 c     Update CCN for CO2 nucleating on H2O CCN :
               ! Warning: must keep memory of it 
-              zq(ig,l,igcm_ccnco2_mass)   = 
-     &             zq(ig,l,igcm_ccnco2_mass)  + dMh2o_ice+dMh2o_ccn
-              zq(ig,l,igcm_ccnco2_number) = 
-     &             zq(ig,l,igcm_ccnco2_number) + dNNh2o
-
-              zq(ig,l,igcm_ccn_number)=zq(ig,l,igcm_ccn_number)-dNNh2o 
-              zq(ig,l,igcm_h2o_ice) = zq(ig,l,igcm_h2o_ice)-dMh2o_ice
-              zq(ig,l,igcm_ccn_mass)= zq(ig,l,igcm_ccn_mass)-dMh2o_ccn
-          
-
-              memdMMh2o(ig,l)=memdMMh2o(ig,l)+dMh2o_ice
-              memdMMccn(ig,l)=memdMMccn(ig,l)+dMh2o_ccn
-              memdNNccn(ig,l)=memdNNccn(ig,l)+dNNh2o
+              if (co2useh2o) then
+                 dNNh2o=dNh2o/tauscaling(ig)
+                 dNNh2o=min(dNNh2o,zq(ig,l,igcm_ccn_number))
+                 ratioh2o_ccn=1./(zq(ig,l,igcm_h2o_ice)
+     &                +zq(ig,l,igcm_ccn_mass)*tauscaling(ig))  
+                 dMh2o_ice=dMh2o*zq(ig,l,igcm_h2o_ice)*ratioh2o_ccn
+                 dMh2o_ccn=dMh2o*zq(ig,l,igcm_ccn_mass)*
+     &                tauscaling(ig)*ratioh2o_ccn
+                 dMh2o_ccn=dMh2o_ccn/tauscaling(ig)
+                 dMh2o_ccn=min(dMh2o_ccn,zq(ig,l,igcm_ccn_mass))
+                 dMh2o_ice=min(dMh2o_ice,zq(ig,l,igcm_h2o_ice))
+                 zq(ig,l,igcm_ccnco2_mass)   = 
+     &                zq(ig,l,igcm_ccnco2_mass)  + dMh2o_ice+dMh2o_ccn
+                 zq(ig,l,igcm_ccnco2_number) = 
+     &                zq(ig,l,igcm_ccnco2_number) + dNNh2o
+                zq(ig,l,igcm_ccn_number)=zq(ig,l,igcm_ccn_number)-dNNh2o 
+                zq(ig,l,igcm_h2o_ice) = zq(ig,l,igcm_h2o_ice)-dMh2o_ice
+                zq(ig,l,igcm_ccn_mass)= zq(ig,l,igcm_ccn_mass)-dMh2o_ccn
+                memdMMh2o(ig,l)=memdMMh2o(ig,l)+dMh2o_ice
+                memdMMccn(ig,l)=memdMMccn(ig,l)+dMh2o_ccn
+                memdNNccn(ig,l)=memdNNccn(ig,l)+dNNh2o
+             endif !of if co2useh2o
            ENDIF                ! of is satu >1
 !=============================================================
